<?php
session_start();
$time_start = microtime(true); 
include "../../inc/config.php";
require('../../lib/simplexlsx.class.php');
session_check();
switch ($_GET["act"]) {
case 'download_sample':

      require_once '../Writer.php';
      $writer = new XLSXWriter();
$style =
        array (
                      array(
              'border' => array(
                'style' => 'thin',
                'color' => '000000'
                ),
            'allfilleddata' => true
            ),
            array(
                'fill' => array(
                    'color' => 'ff0000'
                    ),
                'cells' => array(
                    'A1',
                    'B1',
                    'C1',
                    'E1',
                    'H1',
                    'I1',
                    'J1',
                    'K1'
                    ),
                'border' => array(
                    'style' => 'thin',
                    'color' => '000000'
                    ),
                'verticalAlign' => 'center',
                'horizontalAlign' => 'center',
            ),
                        array(
                'fill' => array(
                    'color' => '00ff00'
                    ),
                'cells' => array(
                      'D1',
                      'F1',
                      'G1'
                    ),
                'border' => array(
                    'style' => 'thin',
                    'color' => '000000'
                    ),
                'verticalAlign' => 'center',
                'horizontalAlign' => 'center',
                )
            );

//column width
$col_width = array(
  1 => 12,
  2 => 16,
  3 => 15,
  4 => 15,
  5 => 13,
  6 => 13,
  7 => 13,
  8 => 13,
  9 => 13,
  10 => 13,
  11 => 13
  );
$writer->setColWidth($col_width);

$header = array(
  'Semester'=>'string',
  'ID AKTIVITAS'=>'string',
  'NIM'=>'string',
  'Nama Mahasiswa'=>'string',
  'Kode MK'=>'string',
  'Nama MK'=>'string',
  'SKS' => 'string',
  'Nilai Huruf'=>'string',
  'Nilai Indeks' => 'string',
  'Nilai Angka' => 'string',
  'Kode Prodi'=>'string'
);

      $no=1;
      $index = 2;

      $data_rec = array();
              $datas = json_decode(file_get_contents('data.json'));
              foreach ($datas as $key) {
                   $data_rec[] = array(
                      $key->semester,
                      $key->id_aktivitas,
                      $key->nim,
                      $key->nama,
                      $key->kode_mk,
                      $key->nama_mk,
                      $key->sks,
                      $key->nilai_huruf,
                      $key->nilai_indeks,
                      $key->nilai_angka,
                      $key->kode_jurusan
                  );
              }

      $comments = array(
      'A1' => 'Semester:
Periode Semester
tahun+semester
ganjil 1, genap 2, perbaikan 3
contoh 20231 berarti 2023 ganjil
Info : Wajib Diisi',
      'B1' => '
Diisi sama dengan id di akvitias mahasiswa, ke aktivitas mana Nilai Konversi ini akan dimasukan

jika kampus merdeka, gunakan Id dari neo, download Aktivitas Mahasiswa dari Menu Tool -> Data Downloader -> Download Aktivitas Mhs, Di Hasil download kolom terakhir ada ID Neo Berupa Id seperti format 0e9d43ec-9b78-4df1-896e-6ea160d0588c
info : wajib disi',
      'C1' => '
      info : Wajib disi',
      'D1' => '
      info : Boleh Kosong',
      'E1' => '
      info : Wajib disi',
      'F1' => '
      info : Boleh Kosong',
      'G1' => '
      Jika dikosongkan, maka akan diambil dari data sks matakuliah feeder',
      'H1' => '
      info : Wajib disi',
      'I1' => '
      info : Wajib disi',
      'J1' => '
      info : Wajib disi',
      'K1' => '
      info : Wajib disi'
      );
      $writer->setComment($comments);
      $filename = 'template_nilai_kampus_merdeka.xlsx';
      header('Content-disposition: attachment; filename="'.XLSXWriter::sanitize_filename($filename).'"');
      header("Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
      header('Content-Transfer-Encoding: binary');
      header('Cache-Control: must-revalidate');
      header('Pragma: public');

      $writer->writeSheet($data_rec,'Sample', $header, $style);
      $writer->writeToStdOut();
      exit(0);
      break;
   case 'delete_error':
    $db->fetch_custom("delete from nilai_kampus_merdeka where status_error=2 and kode_jurusan='".$_POST['id']."'");
    break;
    case 'delete_all':
  
    $status = $_POST['status'];
    if ($status=='all') {
        $status = '';
    } elseif ($status=='0') {
        $status = "and status_error ='0'";
    } elseif ($status=='1') {
        $status = "and status_error ='1'";
    } elseif ($status=='2') {
        $status = "and status_error ='2'";
    }

    if ($_POST['jurusan']=='all') {
        $jurusan = "";
    } else {
        $jurusan = "and kode_jurusan='".$_POST['jurusan']."'";
    }

        if ($_POST['sem']=='all') {
        $semester = "";
    } else {
        $semester = "and semester='".$_POST['sem']."'";
    }

      if ($status=="" && $jurusan=="" && $semester=="") {
      
      if ($_SESSION['level']==1) {
         $db->fetch_custom("TRUNCATE `nilai_kampus_merdeka`");
       } else {
          $db->fetch_custom("delete from nilai_kampus_merdeka where kode_jurusan='".$_SESSION['jurusan']."'");
       }
    } else {
      $ids = $db->fetch_custom("select id from nilai_kampus_merdeka where id!='' $semester $jurusan $status");
      foreach ($ids as $id) {
        $id_delete[] = $id->id;
      }
        $data_id = implode(",", $id_delete);
       $data_mhs_pt = $db->fetch_custom("delete from nilai_kampus_merdeka where id!='' $semester $jurusan $status and id in ($data_id)");
    }


    
    break;
case 'import':

   if (!preg_match("/.(xls|xlsx)$/i", $_FILES["semester"]["name"]) ) {

              echo "pastikan file yang anda pilih xls|xlsx";
              exit();

            } else {
              move_uploaded_file($_FILES["semester"]["tmp_name"], "../../../upload/nilai/".$_FILES['semester']['name']);
              $semester = array("semester"=>$_FILES["semester"]["name"]);

            }



$error_count = 0;
$error = array();
$sukses = 0;
$values = "";
$insert_data = array();

  $Reader = new SimpleXLSX("../../../upload/nilai/".$_FILES['semester']['name']);
  foreach( $Reader->rows() as $key => $val ) {
      if ($key>0) {
        if ($val[0]!="") {
          $check = $db->check_exist('nilai_kampus_merdeka',
            array(
              'nim' => $db->trimmer($val[2]),
              'id_aktivitas'=> $db->trimmer($val[1]),
              'kode_mk'=> $db->trimmer($val[4])
            ));
            if ($check==true) {
              $error_count++;
              $error[] = $val[1]."Nilai ini Sudah Ada";
            } else {
              $sukses++;
                $insert_data[] = array(
                  'semester' => $db->trimmer($val[0]),
                  'id_aktivitas' => $db->trimmer($val[1]),
                  'nim' => $db->trimmer($val[2]),
                  'nama' => $db->trimmer($val[3]),
                  'kode_mk' => $db->trimmer($val[4]),
                  'nama_mk' => $db->trimmer($val[5]),
                  'sks' => $db->trimmer($val[6]),
                  'nilai_huruf' => $db->trimmer($val[7]),
                  'nilai_indeks' => $db->trimmer($val[8]),
                  'nilai_angka' => $db->trimmer($val[9]),
                  'kode_jurusan' => $db->trimmer($val[10])
                );
              }
      }
    }
}


if (!empty($insert_data)) {
  $db->insertMulti('nilai_kampus_merdeka',$insert_data);
  echo $db->getErrorMessage();
}

    unlink("../../../upload/nilai/".$_FILES['semester']['name']);
    $msg = '';
$time_end = microtime(true);
$execution_time = ($time_end - $time_start);
if (($sukses>0) || ($error_count>0)) {
  $msg =  "<div class=\"alert alert-warning alert-dismissible\" role=\"alert\" >
  <button type=\"button\" class=\"close\" data-dismiss=\"alert\" aria-hidden=\"true\">×</button>
      <font color=\"#3c763d\">".$sukses." data Nilai Konversi baru berhasil di import</font><br />
      <font color=\"#ce4844\" >".$error_count." data tidak bisa ditambahkan </font>";
      if (!$error_count==0) {
        $msg .= "<a data-toggle=\"collapse\" href=\"#collapseExample\" aria-expanded=\"false\" aria-controls=\"collapseExample\">Detail error</a>";
      }
      //echo "<br />Total: ".$i." baris data";
      $msg .= "<div class=\"collapse\" id=\"collapseExample\">";
          $i=1;
          foreach ($error as $pesan) {
              $msg .= "<div class=\"bs-callout bs-callout-danger\">".$i.". ".$pesan."</div><br />";
            $i++;
            }
      $msg .= "</div>
    </div>";
            $msg .= "<p>Total Waktu Import : ". waktu_import($execution_time);
}
  echo $msg;
    break;

  case "delete":
    
    
    
    $db->delete("nilai_kampus_merdeka","id",$_GET["id"]);
    break;

      case 'del_massal':
    $data_ids = $_REQUEST['data_ids'];
    if(trim($data_ids)!="") {
        $delete =  $db->fetch_custom("delete from nilai_kampus_merdeka where id in ($data_ids)");
    }
    break;
  case "in":
  
  $data = array(
    "semester"=>$_POST["semester"],
    "id_aktivitas"=>$_POST["id_aktivitas"],
    "nim"=>$_POST["nim"],
    "nama"=>$_POST["nama"],
    "kode_mk"=>$_POST["kode_mk"],
    "nama_mk"=>$_POST["nama_mk"],
    "sks"=>$_POST["sks"],
    "nilai_angka"=>$_POST["nilai_angka"],
    "nilai_huruf"=>$_POST["nilai_huruf"],
    "nilai_indeks"=>$_POST["nilai_indeks"],
    "kode_jurusan"=>$_POST["kode_jurusan"]
  );
  
  
  
   
    $in = $db->insert("nilai_kampus_merdeka",$data);
    
    if ($in=true) {
      echo "good";
    } else {
      return false;
    }
    break;
  case "delete":
    
    
    
    $db->delete("nilai_kampus_merdeka","id",$_GET["id"]);
    break;
  case "up":
  $data = array(
    "semester"=>$_POST["semester"],
    "id_aktivitas"=>$_POST["id_aktivitas"],
    "nim"=>$_POST["nim"],
    "nama"=>$_POST["nama"],
    "kode_mk"=>$_POST["kode_mk"],
    "nama_mk"=>$_POST["nama_mk"],
    "sks"=>$_POST["sks"],
    "nilai_angka"=>$_POST["nilai_angka"],
    "nilai_huruf"=>$_POST["nilai_huruf"],
    "nilai_indeks"=>$_POST["nilai_indeks"],
    "kode_jurusan"=>$_POST["kode_jurusan"]
  );
  
  

    
    $up = $db->update("nilai_kampus_merdeka",$data,"id",$_POST["id"]);
    if ($up=true) {
      echo "good";
    } else {
      return false; 
    }
    break;
  default:
    # code...
    break;
}

?>